## intel-opencl-clang 8.0.0

=== CMakeLists.txt ===
project( common_clang )
cmake_minimum_required(VERSION 3.4.3)

# Do not omit TARGET_OBJECTS expression from the SOURCES target
# property
# `cmake --help-policy CMP0051` for details.
cmake_policy(SET CMP0051 NEW)
cmake_policy(SET CMP0057 NEW)
cmake_policy(SET CMP0022 NEW)

set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(CMakeFunctions)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(USE_PREBUILT_LLVM ON)

    add_definitions(-DUSE_PREBUILT_LLVM)

    if(NOT PREFERRED_LLVM_VERSION)
        set(PREFERRED_LLVM_VERSION "8.0.0")
    endif(NOT PREFERRED_LLVM_VERSION)
    message(STATUS "Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
    find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)

    message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
    message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")

    set(CMAKE_MODULE_PATH
      ${CMAKE_MODULE_PATH}
      ${LLVM_CMAKE_DIR})

    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)

    option(LLVMSPIRV_INCLUDED_IN_LLVM
      "Set to ON if libLLVMSPIRVLib is linked into libLLVM" ON)
    if(LLVMSPIRV_INCLUDED_IN_LLVM)
        message(STATUS "Assuming that libLLVMSPIRVLib is linked into libLLVM")
    else(LLVMSPIRV_INCLUDED_IN_LLVM)
        message(STATUS
          "Assuming that libLLVMSPIRVLib is NOT linked into libLLVM")
        if(NOT SPIRV_TRANSLATOR_DIR)
            message(FATAL_ERROR "SPIRV_TRANSLATOR_DIR is required")
        endif(NOT SPIRV_TRANSLATOR_DIR)
    endif(LLVMSPIRV_INCLUDED_IN_LLVM)
else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(USE_PREBUILT_LLVM OFF)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

include(AddLLVM)
include(TableGen)

find_package(Git REQUIRED)

if (NOT WIN32)
    add_subdirectory( linux_linker )
endif()

if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(ADDR 32)
else ()
    set(ADDR 64)
endif (CMAKE_SIZEOF_VOID_P EQUAL 4)

# set windows binary suffix
if (WIN32)
    set (BUILD_PLATFORM ${ADDR})
else (WIN32)
    set (BUILD_PLATFORM "")
endif (WIN32)

# set that name of the main output file as a target name
if (NOT DEFINED COMMON_CLANG_LIBRARY_NAME)
    set(COMMON_CLANG_LIBRARY_NAME common_clang)
endif()
set(TARGET_NAME ${COMMON_CLANG_LIBRARY_NAME}${BUILD_PLATFORM} )

if(NOT USE_PREBUILT_LLVM)
    set(TARGET_BRANCH "ocl-open-80")
    set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
    set(CLANG_BASE_REVISION a03da8be08a208122e292016cb6cea1f30229677)

    set(SPIRV_SOURCE_DIR ${LLVM_SOURCE_DIR}/projects/llvm-spirv)
    set(SPIRV_BASE_REVISION 049776f815b12525dcd7a0869e0ee68a70d01b92)

    apply_patches(${CLANG_SOURCE_DIR}
                  ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang
                  ${CLANG_BASE_REVISION}
                  ${TARGET_BRANCH})
    apply_patches(${SPIRV_SOURCE_DIR}
                  ${CMAKE_CURRENT_SOURCE_DIR}/patches/spirv
                  ${SPIRV_BASE_REVISION}
                  ${TARGET_BRANCH})
endif(NOT USE_PREBUILT_LLVM)

#
# TblGen the options include file
#
set (COMPILE_OPTIONS_TD  opencl_clang_options.td)
set (COMPILE_OPTIONS_INC opencl_clang_options.inc)

set(LLVM_TABLEGEN_EXE "llvm-tblgen")
set(LLVM_TARGET_DEFINITIONS ${COMPILE_OPTIONS_TD})
if(USE_PREBUILT_LLVM)
  set(TABLEGEN_ADDITIONAL -I ${LLVM_INCLUDE_DIRS})
else(USE_PREBUILT_LLVM)
  set(TABLEGEN_ADDITIONAL "")
endif(USE_PREBUILT_LLVM)
tablegen(LLVM ${COMPILE_OPTIONS_INC} -gen-opt-parser-defs ${TABLEGEN_ADDITIONAL})
add_public_tablegen_target(CClangCompileOptions)

#
# Source code
#
set(TARGET_INCLUDE_FILES
    common_clang.h
    options.h
    binary_result.h
    pch_mgr.h
    ${COMPILE_OPTIONS_TD}
    ${COMPILE_OPTIONS_INC}
)

set(TARGET_SOURCE_FILES
    common_clang.cpp
    options.cpp
    pch_mgr.cpp
    options_compile.cpp
)

#
# Resources
#

set( PRODUCT_VER_MAJOR 2 )
set( PRODUCT_VER_MINOR 0 )
set (LLVM_VER_MAJOR ${LLVM_VERSION_MAJOR} )
set (LLVM_VER_MINOR ${LLVM_VERSION_MINOR} )

add_definitions( -D__STDC_LIMIT_MACROS )
add_definitions( -D__STDC_CONSTANT_MACROS )
add_definitions( -DCOMMON_CLANG_EXPORTS )
if (NOT WIN32)
    add_definitions( -DLIBCOMMON_CLANG_NAME="lib${COMMON_CLANG_LIBRARY_NAME}.so")
endif()

#
# Include directories
#

if(NOT USE_PREBUILT_LLVM)
    set(CLANG_BINARY_DIR ${LLVM_BINARY_DIR}/tools/clang/)
    set(CLANG_SOURCE_DIR ${LLVM_MAIN_SRC_DIR}/tools/clang/)
    include_directories(
        ${CLANG_BINARY_DIR}/include # for tablegened includes
        ${CLANG_SOURCE_DIR}/include # for basic headers
        ${SPIRV_SOURCE_DIR}/include)
endif(NOT USE_PREBUILT_LLVM)

if(USE_PREBUILT_LLVM AND NOT LLVMSPIRV_INCLUDED_IN_LLVM)
    include_directories(${SPIRV_TRANSLATOR_DIR}/include)
    link_directories(${SPIRV_TRANSLATOR_DIR}/lib${LLVM_LIBDIR_SUFFIX})
endif(USE_PREBUILT_LLVM AND NOT LLVMSPIRV_INCLUDED_IN_LLVM)

include_directories( AFTER
            ${LLVM_INCLUDE_DIRS}
            ${CMAKE_CURRENT_BINARY_DIR}
            ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}
            )

link_directories(
    ${LLVM_LIBRARY_DIRS}
)

set(ADDITIONAL_LIBS ${CMAKE_DL_LIBS})

if(NOT LLVMSPIRVLib IN_LIST LLVM_AVAILABLE_LIBS)
  # SPIRV-LLVM-Translator is not included into LLVM as a component.
  # So, we need to list it here explicitly as an external library
  list(APPEND ADDITIONAL_LIBS LLVMSPIRVLib)
endif()

add_subdirectory(cl_headers)

set(LLVM_REQUIRES_EH ON)

add_llvm_library(${TARGET_NAME} SHARED
  ${TARGET_INCLUDE_FILES}
  ${TARGET_SOURCE_FILES}
  $<TARGET_OBJECTS:cl_headers>

  DEPENDS CClangCompileOptions
  LINK_COMPONENTS
    all
  LINK_LIBS
# The list of clang libraries is taken from clang makefile
# (build/tools/clang/tools/driver/CMakeFiles/clang.dir/link.txt)
# All duplicate libraries are there on purpose
    clangBasic
    clangCodeGen
    clangDriver
    clangFrontend
    clangFrontendTool
    clangCodeGen
    clangRewriteFrontend
    clangARCMigrate
    clangStaticAnalyzerFrontend
    clangStaticAnalyzerCheckers
    clangStaticAnalyzerCore
    clangCrossTU
    clangIndex
    clangFrontend
    clangDriver
    clangParse
    clangSerialization
    clangSema
    clangAnalysis
    clangEdit
    clangFormat
    clangToolingInclusions
    clangToolingCore
    clangRewrite
    clangASTMatchers
    clangAST
    clangLex
    clangBasic
    ${ADDITIONAL_LIBS}
  )

# Configure resource file on Windows
if (WIN32)
    # windows_resource_file should be defined by llvm_add_library and should
    # contain full patch to a .rc file
    # It also might not be defined if this library is built out-of-tree:
    # let's use our copy of .rc file from LLVM source tree in that case
    if (NOT DEFINED windows_resource_file)
        set(windows_resource_file windows_resource_file.rc)
    endif(NOT DEFINED windows_resource_file)

    set(RC_CHAR_TM "\\231")
    set(RC_CHAR_C "\\251")
    set(RC_CHAR_R "\\256")

    set(RC_FILE_VERSION "${PRODUCT_VER_MAJOR}.${PRODUCT_VER_MINOR}.${LLVM_VER_MAJOR}.${LLVM_VER_MINOR}")
    set(RC_PRODUCT_NAME "Intel${RC_CHAR_R} Front-end Library for OpenCL${RC_CHAR_TM} software")

    # Adjust content of the resource file by specifying compile definitions
    set_property(SOURCE ${windows_resource_file}
        PROPERTY COMPILE_DEFINITIONS
            "RC_VERSION_FIELD_1=${PRODUCT_VER_MAJOR}"
            "RC_VERSION_FIELD_2=${PRODUCT_VER_MINOR}"
            "RC_VERSION_FIELD_3=${LLVM_VER_MAJOR}"
            "RC_VERSION_FIELD_4=${LLVM_VER_MINOR}"
            "RC_COMPANY_NAME=\"Intel Corporation\""
            "RC_FILE_DESCRIPTION=\"${RC_PRODUCT_NAME}\""
            "RC_FILE_VERSION=\"${RC_FILE_VERSION}\""
            "RC_INTERNAL_NAME=\"${TARGET_NAME}\""
            "RC_ORIGINAL_FILENAME=\"${TARGET_NAME}.dll\""
            "RC_PRODUCT_NAME=\"${RC_PRODUCT_NAME}\""
            "RC_PRODUCT_VERSION=\"${RC_FILE_VERSION}\""
            "RC_COPYRIGHT=\"Copyright ${RC_CHAR_C} 2018 Intel Corporation. All rights reserved.\"")
elseif(UNIX)
    set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
                      LINK_FLAGS " -Wl,--no-undefined")
endif(WIN32)

install(FILES common_clang.h
        DESTINATION include/cclang
        COMPONENT ${TARGET_NAME})

SET_LINUX_EXPORTS_FILE( ${TARGET_NAME} common_clang.map )

add_custom_target(deploy DEPENDS install-${TARGET_NAME})

=== cl_headers/CMakeLists.txt ===
set(CL_HEADERS_LIB cl_headers)
set(CLANG_COMMAND clang)
set(LINUX_RESOURCE_LINKER_COMMAND linux_resource_linker)

function(copy_file SRC DST)
add_custom_command(
    OUTPUT  ${DST}
    MAIN_DEPENDENCY ${SRC}
    COMMAND ${CMAKE_COMMAND} -E copy "${SRC}" "${DST}"
    COMMENT "Copying '${SRC}' to ${DST}"
)
endfunction(copy_file)

if(USE_PREBUILT_LLVM)
    set(OPENCL_HEADERS_DIR
      "${LLVM_LIBRARY_DIRS}/clang/${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH}/include/")
else(USE_PREBUILT_LLVM)
    set(OPENCL_HEADERS_DIR "${CLANG_SOURCE_DIR}/lib/Headers")
endif(USE_PREBUILT_LLVM)
copy_file(${OPENCL_HEADERS_DIR}/opencl-c.h opencl-c.h)

add_custom_target (
    opencl.headers.target
    DEPENDS
    opencl-c.h
)


function(pack_to_obj SRC DST TAG)
    add_custom_command (
        OUTPUT ${DST}
        DEPENDS ${SRC} ${LINUX_RESOURCE_LINKER_COMMAND}
        COMMAND ${LINUX_RESOURCE_LINKER_COMMAND} "${SRC}" "${DST}" "${TAG}"
        COMMENT "Packing ${SRC}"
    )
endfunction(pack_to_obj)

if(WIN32)
    list(APPEND CL_HEADERS_SRC OpenCL.rc)
else()
    pack_to_obj(opencl-c.h           opencl-c.h.cpp           "PCM_OPENCL_C_H")
    list(APPEND CL_HEADERS_SRC
         opencl-c.h.cpp
    )
endif()

add_library(${CL_HEADERS_LIB} OBJECT
    ${CL_HEADERS_SRC}
)

add_dependencies(${CL_HEADERS_LIB} opencl.headers.target)

=== debian/changelog ===
intel-opencl-clang (8.0.0-0ubuntu1) disco; urgency=medium

  * Upload to Ubuntu (LP: #1815552)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 28 Mar 2019 13:56:45 +0200

intel-opencl-clang (8.0.0-1) experimental; urgency=medium

  * New upstream release.
  * control: Bump build-dep on llvm/clang.
  * watch: Added.
  * Follow upstream and rename binaries.
  * dlopen-soname.diff: Make sure the soname is opened instead of linker
    name.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 08 Apr 2019 16:14:20 +0300

intel-opencl-clang (0+git20190318-1) experimental; urgency=medium

  * New upstream snapshot.
  * Build against libllvmspirvlib8.
  * Sync with ocl-open-80 -branch.
  * control: Add homepage.
  * control: Limit to amd64, i386.
  * control: Build with clang-8.
  * Rename binaries back to libcommon-clang*.
  * rules: Fix build against libllvmspirvlib.
  * control: Bump build-dep on libllvmspirvlib-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Mar 2019 18:31:35 +0200

intel-opencl-clang (0+git20190204-1) experimental; urgency=medium

  * Initial release (Closes: #921426)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Feb 2019 11:23:01 +0200

=== debian/control ===
Source: intel-opencl-clang
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper (>= 11),
 clang-8 (>= 1:8-1ubuntu1~),
 cmake,
 git,
 libclang-8-dev (>= 1:8-1ubuntu1~),
 libllvmspirvlib-dev (>= 8.0.0+git20190314),
 llvm-8-dev (>= 1:8-1ubuntu1~),
Standards-Version: 4.3.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang8
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: all
Depends: ${misc:Depends},
 libopencl-clang8 (>= ${source:Version}),
 libopencl-clang8 (<< ${source:Upstream-Version}+1~)
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

## intel-opencl-clang 9.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
     add_definitions(-DUSE_PREBUILT_LLVM)
 
     if(NOT PREFERRED_LLVM_VERSION)
-        set(PREFERRED_LLVM_VERSION "8.0.0")
+        set(PREFERRED_LLVM_VERSION "9.0.0")
     endif(NOT PREFERRED_LLVM_VERSION)
     message(STATUS "Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
     find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)
@@ -74,17 +74,53 @@
 
 # set that name of the main output file as a target name
 if (NOT DEFINED COMMON_CLANG_LIBRARY_NAME)
-    set(COMMON_CLANG_LIBRARY_NAME common_clang)
+    set(COMMON_CLANG_LIBRARY_NAME "opencl-clang")
 endif()
 set(TARGET_NAME ${COMMON_CLANG_LIBRARY_NAME}${BUILD_PLATFORM} )
 
 if(NOT USE_PREBUILT_LLVM)
-    set(TARGET_BRANCH "ocl-open-80")
-    set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
-    set(CLANG_BASE_REVISION a03da8be08a208122e292016cb6cea1f30229677)
-
-    set(SPIRV_SOURCE_DIR ${LLVM_SOURCE_DIR}/projects/llvm-spirv)
-    set(SPIRV_BASE_REVISION 049776f815b12525dcd7a0869e0ee68a70d01b92)
+
+    if(NOT LLVM_EXTERNAL_CLANG_SOURCE_DIR)
+        set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
+    elseif(EXISTS "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/CMakeLists.txt")
+        set(CLANG_SOURCE_DIR "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}")
+    endif()
+    if(EXISTS ${CLANG_SOURCE_DIR})
+        message(STATUS "Using Clang source code direcotry: ${CLANG_SOURCE_DIR}")
+    else()
+        message(FATAL_ERROR
+            "Can't find Clang source code directory!\n"
+            "If you are using LLVM monorepo:\n"
+            "  1. Clean CMake cache: `rm CMakeCache.txt`\n"
+            "  2. Enable Clang project with `-DLLVM_ENABLE_PROJECTS=\"clang\"` option\n"
+            "If Clang is used as a separate repository (not monorepo), it should "
+            "be checked out at `llvm/tools/clang`."
+        )
+    endif()
+
+    if(NOT LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR)
+        set(SPIRV_SOURCE_DIR ${LLVM_SOURCE_DIR}/projects/llvm-spirv)
+    elseif(EXISTS "${LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR}/CMakeLists.txt")
+        set(SPIRV_SOURCE_DIR ${LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR})
+    endif()
+    if(EXISTS ${SPIRV_SOURCE_DIR})
+        message(STATUS "Using SPIRV-LLVM-Translator source code directory: ${SPIRV_SOURCE_DIR}")
+    else()
+        message(FATAL_ERROR
+            "Can't find SPIRV-LLVM-Translator source code dir!\n"
+            "If you are using LLVM monorepo, SPIRV-LLVM-Translator should be checked out "
+            "at '<monorepo_root_dir>/llvm-spirv' and it should be enabled as an external LLVM "
+            "project using the following 2 options:\n"
+            "  -DLLVM_EXTERNAL_PROJECTS=\"opencl-clang;llvm-spirv\"\n"
+            "  -DLLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR=\"<monorepo_root_dir>/llvm-spirv\"\n"
+            "If you are not using LLVM monorepo, SPIRV-LLVM-Translator should be checked "
+            "out at `llvm/projects/llvm-spirv`"
+        )
+    endif()
+
+    set(CLANG_BASE_REVISION master)
+    set(SPIRV_BASE_REVISION master)
+    set(TARGET_BRANCH "ocl-open-90")
 
     apply_patches(${CLANG_SOURCE_DIR}
                   ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang
@@ -143,9 +179,6 @@
 add_definitions( -D__STDC_LIMIT_MACROS )
 add_definitions( -D__STDC_CONSTANT_MACROS )
 add_definitions( -DCOMMON_CLANG_EXPORTS )
-if (NOT WIN32)
-    add_definitions( -DLIBCOMMON_CLANG_NAME="lib${COMMON_CLANG_LIBRARY_NAME}.so")
-endif()
 
 #
 # Include directories
@@ -153,11 +186,10 @@
 
 if(NOT USE_PREBUILT_LLVM)
     set(CLANG_BINARY_DIR ${LLVM_BINARY_DIR}/tools/clang/)
-    set(CLANG_SOURCE_DIR ${LLVM_MAIN_SRC_DIR}/tools/clang/)
     include_directories(
-        ${CLANG_BINARY_DIR}/include # for tablegened includes
-        ${CLANG_SOURCE_DIR}/include # for basic headers
-        ${SPIRV_SOURCE_DIR}/include)
+        ${CLANG_BINARY_DIR}/include  # for tablegened includes
+        ${CLANG_SOURCE_DIR}/include  # for basic headers
+        ${SPIRV_SOURCE_DIR}/include) # for SPIRV headers
 endif(NOT USE_PREBUILT_LLVM)
 
 if(USE_PREBUILT_LLVM AND NOT LLVMSPIRV_INCLUDED_IN_LLVM)
@@ -262,9 +294,18 @@
             "RC_PRODUCT_NAME=\"${RC_PRODUCT_NAME}\""
             "RC_PRODUCT_VERSION=\"${RC_FILE_VERSION}\""
             "RC_COPYRIGHT=\"Copyright ${RC_CHAR_C} 2018 Intel Corporation. All rights reserved.\"")
+
+    # Enable compiler generation of Control Flow Guard security checks.
+    target_compile_options(${TARGET_NAME} PUBLIC "/guard:cf")
+    set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
+        LINK_FLAGS "/DYNAMICBASE /GUARD:CF")
+
 elseif(UNIX)
     set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
-                      LINK_FLAGS " -Wl,--no-undefined")
+        COMPILE_DEFINITIONS LIBCOMMON_CLANG_NAME="$<TARGET_SONAME_FILE_NAME:${TARGET_NAME}>")
+
+    set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
+        LINK_FLAGS " -Wl,--no-undefined")
 endif(WIN32)
 
 install(FILES common_clang.h

=== debian/changelog ===
intel-opencl-clang (9.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Build with llvm9.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 24 Sep 2019 15:08:42 +0300

intel-opencl-clang (8.0.1-1) unstable; urgency=medium

  * New upstream release.
  * dlopen-soname.diff: Dropped, upstream.
  * control: Bump build-dep on libllvmspirvlib-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 10:19:54 +0300

=== debian/control ===
Source: intel-opencl-clang
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper (>= 11),
 clang-9,
 cmake,
 git,
 libclang-9-dev,
 libllvmspirvlib-dev (>= 9.0.0-1~),
 lldb-9,
 llvm-9-dev,
Standards-Version: 4.3.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang9
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: all
Depends: ${misc:Depends},
 libopencl-clang9 (>= ${source:Version}),
 libopencl-clang9 (<< ${source:Upstream-Version}+1~)
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

## intel-opencl-clang 10.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
     add_definitions(-DUSE_PREBUILT_LLVM)
 
     if(NOT PREFERRED_LLVM_VERSION)
-        set(PREFERRED_LLVM_VERSION "9.0.0")
+        set(PREFERRED_LLVM_VERSION "10.0.0")
     endif(NOT PREFERRED_LLVM_VERSION)
     message(STATUS "Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
     find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)
@@ -32,7 +32,7 @@
       ${CMAKE_MODULE_PATH}
       ${LLVM_CMAKE_DIR})
 
-    set(CMAKE_CXX_STANDARD 11)
+    set(CMAKE_CXX_STANDARD 14)
     set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
     option(LLVMSPIRV_INCLUDED_IN_LLVM
@@ -48,12 +48,11 @@
     endif(LLVMSPIRV_INCLUDED_IN_LLVM)
 else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
     set(USE_PREBUILT_LLVM OFF)
+    find_package(Git REQUIRED)
 endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
 
 include(AddLLVM)
 include(TableGen)
-
-find_package(Git REQUIRED)
 
 if (NOT WIN32)
     add_subdirectory( linux_linker )

=== debian/changelog ===
intel-opencl-clang (10.0.0-2) unstable; urgency=medium

  * control: Build -dev on amd64/i386 like the lib. (Closes: #955815)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 08 Apr 2020 21:11:04 +0300

intel-opencl-clang (10.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Build with llvm-10.
  * control: Use debhelper-compat, bump to 12.
  * control: Bump policy to 4.5.0.
  * Link-with-libclang-cpp-for-out-of-tree-build.patch: Add a patch to
    fix build with llvm-10, and add libclang-cpp10-dev to build-
    depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 07 Apr 2020 19:01:48 +0300

=== debian/control ===
Source: intel-opencl-clang
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 12),
 clang-10,
 cmake,
 git,
 libclang-10-dev,
 libclang-cpp10-dev,
 libllvmspirvlib-dev (>= 10.0.0-1~),
 lldb-10,
 llvm-10-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang10
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: amd64 i386
Depends: ${misc:Depends},
 libopencl-clang10 (>= ${source:Version}),
 libopencl-clang10 (<< ${source:Upstream-Version}+1~)
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLLVMSPIRV_INCLUDED_IN_LLVM=OFF \
		-DSPIRV_TRANSLATOR_DIR=/usr/lib \
		-DCOMMON_CLANG_LIBRARY_NAME=opencl-clang \
		-DCMAKE_SKIP_RPATH=true

override_dh_missing:
	dh_missing --fail-missing

gentarball:
	tar --transform 's,^,$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.xz .

## intel-opencl-clang 11.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
     add_definitions(-DUSE_PREBUILT_LLVM)
 
     if(NOT PREFERRED_LLVM_VERSION)
-        set(PREFERRED_LLVM_VERSION "10.0.0")
+        set(PREFERRED_LLVM_VERSION "11.0.0")
     endif(NOT PREFERRED_LLVM_VERSION)
     message(STATUS "Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
     find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)
@@ -80,9 +80,13 @@
 if(NOT USE_PREBUILT_LLVM)
 
     if(NOT LLVM_EXTERNAL_CLANG_SOURCE_DIR)
+        set(LLVM_BASE_REVISION release_11)
         set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
+        set(CLANG_BASE_REVISION release_11)
     elseif(EXISTS "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/CMakeLists.txt")
+        set(LLVM_BASE_REVISION release/11.x)
         set(CLANG_SOURCE_DIR "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}")
+        set(CLANG_BASE_REVISION release/11.x)
     endif()
     if(EXISTS ${CLANG_SOURCE_DIR})
         message(STATUS "Using Clang source code direcotry: ${CLANG_SOURCE_DIR}")
@@ -117,18 +121,25 @@
         )
     endif()
 
-    set(CLANG_BASE_REVISION master)
-    set(SPIRV_BASE_REVISION master)
-    set(TARGET_BRANCH "ocl-open-90")
-
-    apply_patches(${CLANG_SOURCE_DIR}
-                  ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang
-                  ${CLANG_BASE_REVISION}
-                  ${TARGET_BRANCH})
+
+    set(SPIRV_BASE_REVISION llvm_release_110)
+    set(TARGET_BRANCH "ocl-open-110")
+    get_filename_component(LLVM_MONOREPO_DIR ${LLVM_SOURCE_DIR} DIRECTORY)
+    set(LLVM_PATCHES_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/patches/llvm
+                          ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang)
+    apply_patches(${LLVM_MONOREPO_DIR}
+                  "${LLVM_PATCHES_DIRS}"
+                  ${LLVM_BASE_REVISION}
+                  ${TARGET_BRANCH}
+                  ret)
+    if(${ret})
+        add_definitions(-DAPPLIED_LLVM_PATCHES)
+    endif()
     apply_patches(${SPIRV_SOURCE_DIR}
                   ${CMAKE_CURRENT_SOURCE_DIR}/patches/spirv
                   ${SPIRV_BASE_REVISION}
-                  ${TARGET_BRANCH})
+                  ${TARGET_BRANCH}
+                  ret)
 endif(NOT USE_PREBUILT_LLVM)
 
 #
@@ -206,27 +217,22 @@
     ${LLVM_LIBRARY_DIRS}
 )
 
-set(ADDITIONAL_LIBS ${CMAKE_DL_LIBS})
-
-if(NOT LLVMSPIRVLib IN_LIST LLVM_AVAILABLE_LIBS)
+set(OPENCL_CLANG_LINK_LIBS ${CMAKE_DL_LIBS})
+
+if(NOT LLVMSPIRVLib IN_LIST LLVM_AVAILABLE_LIBS OR (USE_PREBUILT_LLVM AND LLVM_LINK_LLVM_DYLIB))
   # SPIRV-LLVM-Translator is not included into LLVM as a component.
   # So, we need to list it here explicitly as an external library
-  list(APPEND ADDITIONAL_LIBS LLVMSPIRVLib)
+  list(APPEND OPENCL_CLANG_LINK_LIBS LLVMSPIRVLib)
 endif()
 
 add_subdirectory(cl_headers)
 
 set(LLVM_REQUIRES_EH ON)
 
-add_llvm_library(${TARGET_NAME} SHARED
-  ${TARGET_INCLUDE_FILES}
-  ${TARGET_SOURCE_FILES}
-  $<TARGET_OBJECTS:cl_headers>
-
-  DEPENDS CClangCompileOptions
-  LINK_COMPONENTS
-    all
-  LINK_LIBS
+if(USE_PREBUILT_LLVM OR CLANG_LINK_CLANG_DYLIB)
+  list(APPEND OPENCL_CLANG_LINK_LIBS clang-cpp)
+else()
+  list(APPEND OPENCL_CLANG_LINK_LIBS
 # The list of clang libraries is taken from clang makefile
 # (build/tools/clang/tools/driver/CMakeFiles/clang.dir/link.txt)
 # All duplicate libraries are there on purpose
@@ -258,7 +264,19 @@
     clangAST
     clangLex
     clangBasic
-    ${ADDITIONAL_LIBS}
+  )
+endif()
+
+add_llvm_library(${TARGET_NAME} SHARED
+  ${TARGET_INCLUDE_FILES}
+  ${TARGET_SOURCE_FILES}
+  $<TARGET_OBJECTS:cl_headers>
+
+  DEPENDS CClangCompileOptions
+  LINK_COMPONENTS
+    all
+  LINK_LIBS
+    ${OPENCL_CLANG_LINK_LIBS}
   )
 
 # Configure resource file on Windows

=== cl_headers/CMakeLists.txt ===
--- 
+++ 
@@ -18,11 +18,13 @@
     set(OPENCL_HEADERS_DIR "${CLANG_SOURCE_DIR}/lib/Headers")
 endif(USE_PREBUILT_LLVM)
 copy_file(${OPENCL_HEADERS_DIR}/opencl-c.h opencl-c.h)
+copy_file(${OPENCL_HEADERS_DIR}/opencl-c-base.h opencl-c-base.h)
 
 add_custom_target (
     opencl.headers.target
     DEPENDS
     opencl-c.h
+    opencl-c-base.h
 )
 
 
@@ -39,8 +41,10 @@
     list(APPEND CL_HEADERS_SRC OpenCL.rc)
 else()
     pack_to_obj(opencl-c.h           opencl-c.h.cpp           "PCM_OPENCL_C_H")
+    pack_to_obj(opencl-c-base.h      opencl-c-base.h.cpp      "PCM_OPENCL_C_BASE_H")
     list(APPEND CL_HEADERS_SRC
-         opencl-c.h.cpp
+      opencl-c.h.cpp
+      opencl-c-base.h.cpp
     )
 endif()

=== debian/changelog ===
intel-opencl-clang (11.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 12 Nov 2020 12:59:06 +0200

intel-opencl-clang (11.0~git20200922-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build with llvm-11.
  * Link-with-libclang-cpp-for-out-of-tree-build.patch: Dropped,
    upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 22 Sep 2020 20:42:53 +0300

=== debian/control ===
Source: intel-opencl-clang
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 12),
 clang-11,
 cmake,
 git,
 libclang-11-dev,
 libclang-cpp11-dev,
 libllvmspirvlib-dev (>= 11.0~),
 lldb-11,
 llvm-11-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang11
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: amd64 i386
Depends: ${misc:Depends},
 libopencl-clang11 (>= ${source:Version}),
 libopencl-clang11 (<< ${source:Upstream-Version}+1~)
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

## intel-opencl-clang 12.0.0

=== debian/changelog ===
intel-opencl-clang (12.0.0-1) experimental; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 07 Jun 2021 12:32:32 +0300

intel-opencl-clang (12.0~git20210510-1) experimental; urgency=medium

  * New upstream snapshot.
    - build with llvm-12

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 May 2021 17:58:01 +0300

=== debian/control ===
Source: intel-opencl-clang
Section: libs
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 12),
 clang-12,
 cmake,
 git,
 libclang-12-dev,
 libclang-cpp12-dev,
 libllvmspirvlib-dev (>= 12.0~),
 lldb-12,
 llvm-12-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang12
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: amd64 i386
Depends: ${misc:Depends},
 libopencl-clang12 (>= ${source:Version}),
 libopencl-clang12 (<< ${source:Upstream-Version}+1~)
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

## intel-opencl-clang 13.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,13 +20,13 @@
     add_definitions(-DUSE_PREBUILT_LLVM)
 
     if(NOT PREFERRED_LLVM_VERSION)
-        set(PREFERRED_LLVM_VERSION "11.0.0")
+        set(PREFERRED_LLVM_VERSION "12.0.0")
     endif(NOT PREFERRED_LLVM_VERSION)
-    message(STATUS "Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
+    message(STATUS "[OPENCL-CLANG] Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
     find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)
 
-    message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
-    message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
+    message(STATUS "[OPENCL-CLANG] Using LLVMConfig.cmake in: ${LLVM_DIR}")
+    message(STATUS "[OPENCL-CLANG] Found LLVM ${LLVM_PACKAGE_VERSION}")
 
     set(CMAKE_MODULE_PATH
       ${CMAKE_MODULE_PATH}
@@ -38,12 +38,12 @@
     option(LLVMSPIRV_INCLUDED_IN_LLVM
       "Set to ON if libLLVMSPIRVLib is linked into libLLVM" ON)
     if(LLVMSPIRV_INCLUDED_IN_LLVM)
-        message(STATUS "Assuming that libLLVMSPIRVLib is linked into libLLVM")
+        message(STATUS "[OPENCL-CLANG] Assuming that libLLVMSPIRVLib is linked into libLLVM")
     else(LLVMSPIRV_INCLUDED_IN_LLVM)
         message(STATUS
-          "Assuming that libLLVMSPIRVLib is NOT linked into libLLVM")
+          "[OPENCL-CLANG] Assuming that libLLVMSPIRVLib is NOT linked into libLLVM")
         if(NOT SPIRV_TRANSLATOR_DIR)
-            message(FATAL_ERROR "SPIRV_TRANSLATOR_DIR is required")
+            message(FATAL_ERROR "[OPENCL-CLANG] SPIRV_TRANSLATOR_DIR is required")
         endif(NOT SPIRV_TRANSLATOR_DIR)
     endif(LLVMSPIRV_INCLUDED_IN_LLVM)
 else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
@@ -80,19 +80,19 @@
 if(NOT USE_PREBUILT_LLVM)
 
     if(NOT LLVM_EXTERNAL_CLANG_SOURCE_DIR)
-        set(LLVM_BASE_REVISION release_11)
+        set(LLVM_BASE_REVISION release_13)
         set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
-        set(CLANG_BASE_REVISION release_11)
+        set(CLANG_BASE_REVISION release_13)
     elseif(EXISTS "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/CMakeLists.txt")
-        set(LLVM_BASE_REVISION release/11.x)
+	    set(LLVM_BASE_REVISION release/13.x)
         set(CLANG_SOURCE_DIR "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}")
-        set(CLANG_BASE_REVISION release/11.x)
+        set(CLANG_BASE_REVISION release/13.x)
     endif()
     if(EXISTS ${CLANG_SOURCE_DIR})
-        message(STATUS "Using Clang source code direcotry: ${CLANG_SOURCE_DIR}")
+        message(STATUS "[OPENCL-CLANG] Using Clang source code direcotry: ${CLANG_SOURCE_DIR}")
     else()
         message(FATAL_ERROR
-            "Can't find Clang source code directory!\n"
+            "[OPENCL-CLANG] Can't find Clang source code directory!\n"
             "If you are using LLVM monorepo:\n"
             "  1. Clean CMake cache: `rm CMakeCache.txt`\n"
             "  2. Enable Clang project with `-DLLVM_ENABLE_PROJECTS=\"clang\"` option\n"
@@ -107,10 +107,10 @@
         set(SPIRV_SOURCE_DIR ${LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR})
     endif()
     if(EXISTS ${SPIRV_SOURCE_DIR})
-        message(STATUS "Using SPIRV-LLVM-Translator source code directory: ${SPIRV_SOURCE_DIR}")
+        message(STATUS "[OPENCL-CLANG] Using SPIRV-LLVM-Translator source code directory: ${SPIRV_SOURCE_DIR}")
     else()
         message(FATAL_ERROR
-            "Can't find SPIRV-LLVM-Translator source code dir!\n"
+            "[OPENCL-CLANG] Can't find SPIRV-LLVM-Translator source code dir!\n"
             "If you are using LLVM monorepo, SPIRV-LLVM-Translator should be checked out "
             "at '<monorepo_root_dir>/llvm-spirv' and it should be enabled as an external LLVM "
             "project using the following 2 options:\n"
@@ -120,10 +120,9 @@
             "out at `llvm/projects/llvm-spirv`"
         )
     endif()
-
-
-    set(SPIRV_BASE_REVISION llvm_release_110)
-    set(TARGET_BRANCH "ocl-open-110")
+    
+    set(SPIRV_BASE_REVISION llvm_release_130)
+    set(TARGET_BRANCH "ocl-open-130")
     get_filename_component(LLVM_MONOREPO_DIR ${LLVM_SOURCE_DIR} DIRECTORY)
     set(LLVM_PATCHES_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/patches/llvm
                           ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang)
@@ -132,9 +131,6 @@
                   ${LLVM_BASE_REVISION}
                   ${TARGET_BRANCH}
                   ret)
-    if(${ret})
-        add_definitions(-DAPPLIED_LLVM_PATCHES)
-    endif()
     apply_patches(${SPIRV_SOURCE_DIR}
                   ${CMAKE_CURRENT_SOURCE_DIR}/patches/spirv
                   ${SPIRV_BASE_REVISION}

=== debian/changelog ===
intel-opencl-clang (13.0.0-3) unstable; urgency=medium

  * control: Add Conflicts/Replaces/Provides: libopencl-clang-x.y-dev.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 22 Feb 2022 01:21:52 +0100

intel-opencl-clang (13.0.0-2) unstable; urgency=medium

  * rules: Parse llvm version from Build-Depends.
  * control: Build-depend on libllvmspirvlib-13-dev.
  * control: Provide virtual package libopencl-clang-13-dev.
  * control: Drop Build-Depends: lldb-13, apparently unused.
  * control: Set Architecture: any.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * Add myself to Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 17 Feb 2022 09:27:23 +0100

intel-opencl-clang (13.0.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 27 Oct 2021 11:02:35 +0300

intel-opencl-clang (13.0~git20210929-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build with llvm 13.
  * rules: Set llvm version.
  * control: Drop git from build-depends, not used anymore.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 29 Sep 2021 15:09:59 +0300

intel-opencl-clang (12.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Aug 2021 09:57:54 +0300

=== debian/control ===
Source: intel-opencl-clang
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 clang-13,
 cmake,
 libclang-13-dev,
 libclang-cpp13-dev,
 libllvmspirvlib-13-dev,
 llvm-13-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/intel-opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/intel-opencl-clang.git

Package: libopencl-clang13
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libopencl-clang13 (= ${binary:Version}),
Conflicts:
 libopencl-clang-x.y-dev,
Replaces:
 libopencl-clang-x.y-dev,
Provides:
 libopencl-clang-13-dev,
 libopencl-clang-x.y-dev,
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/pkg-info.mk
+
+LLVM_VERSION		 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
+LLVM_UPSTREAM_VERSION	 = $(shell dpkg-query -f '$${source:Upstream-Version}\n' -W llvm-$(LLVM_VERSION)-dev)
 
 %:
 	dh $@ --builddir build/
@@ -10,10 +13,9 @@
 		-DLLVMSPIRV_INCLUDED_IN_LLVM=OFF \
 		-DSPIRV_TRANSLATOR_DIR=/usr/lib \
 		-DCOMMON_CLANG_LIBRARY_NAME=opencl-clang \
-		-DCMAKE_SKIP_RPATH=true
+		-DCMAKE_SKIP_RPATH=true \
+		-DPREFERRED_LLVM_VERSION=$(LLVM_UPSTREAM_VERSION)
 
-override_dh_missing:
-	dh_missing --fail-missing
 
 gentarball:
 	tar --transform 's,^,$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)/,' \

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%intel-opencl-clang-$1.tar.gz%" \
   https://github.com/intel/opencl-clang/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
